unit TestServerRDM;

interface

uses
  Windows, Messages, SysUtils, Classes, ComServ, ComObj, VCLCom, DataBkr,
  DBClient, MIDASTestWithSecurityServerApp_TLB, StdVcl, Provider;

type
  TTestWithSecurity = class(TRemoteDataModule, ITestWithSecurity)
    dspTest: TDataSetProvider;
    function dspTestDataRequest(Sender: TObject;
      Input: OleVariant): OleVariant;
  private
    { Private declarations }
  protected
    class procedure UpdateRegistry(Register: Boolean; const ClassID, ProgID: string); override;
  public
    { Public declarations }
  end;

implementation

{$R *.DFM}

class procedure TTestWithSecurity.UpdateRegistry(Register: Boolean; const ClassID, ProgID: string);
begin
  if Register then
  begin
    inherited UpdateRegistry(Register, ClassID, ProgID);
    EnableSocketTransport(ClassID);
    EnableWebTransport(ClassID);
  end else
  begin
    DisableSocketTransport(ClassID);
    DisableWebTransport(ClassID);
    inherited UpdateRegistry(Register, ClassID, ProgID);
  end;
end;

function TTestWithSecurity.dspTestDataRequest(Sender: TObject;
  Input: OleVariant): OleVariant;
begin
  result :=  DateTimeToStr(Now);
end;

initialization
  TComponentFactory.Create(ComServer, TTestWithSecurity,
    Class_TestWithSecurity, ciMultiInstance, tmApartment);
end.
